;***************************************************************************************************************
;* This program reads in the DESKTOP.INF file and uses the data found to set the desktop colors, mouse click
;* speed, keyboard delay and repeat speeds, and six printer options. Normally you would need the control panel/
;* printer options accessory to be installed to set these options.
;***************************************************************************************************************
CONTERM    =           $484              ;Location of attributes word for consol output in GEMDOS variables area
           DATA
;The following variables come from AssemPro's macro facilities
GLOBAL     DC.W        0
APVERSION  =           GLOBAL
APCOUNT    DC.W        0
AP_ID      DC.W        0
APPRIVATE  DC.L        0
APPTREE    DC.L        0
AP1RESV    DC.L        0
AP2RESV    DC.L        0
AP3RESV    DC.L        0
AP4RESV    DC.L        0
WORK_IN    DC.W        1,1,1,1,1,1,1,1,1,1,2
           BSS
ACC_ID     DS.W        1
AESPTR     DC.L        0
VDIPTR     DC.L        0
AESPB      DS.L        6
VDIPB      DS.L        5
CONTRL     DC.W        0
OPCODE     =           CONTRL
SINTIN     DC.W        0
SINTOUT    DC.W        0
SADDRIN    DC.W        0
SADDROUT   DC.W        0
           DS.W        6
HANDLE     DS.W        1
GR_HANDLE  DS.W        1
GR_HWCHAR  DS.W        1
GR_HHCHAR  DS.W        1
GR_HWBOX   DS.W        1
GR_HHBOX   DS.W        1
INTIN      DS.W        128
PTSIN      DS.W        256
INTOUT     DS.W        128
PTSOUT     DS.W        128
ADDRIN     DS.W        128
ADDROUT    DS.W        128
WORK_OUT   DS.W        57

           TEXT

; This next block puts the addresses of the various needed arrays into the VDI parameter block
; and the AES parameter block and then puts VDIPB and AESPB into the needed VDIPTR and AESPTR
           LEA         VDIPB+20,A7       ;This code was taken from the AssemPro macro package
           PEA         PTSOUT
           PEA         INTOUT
           PEA         PTSIN
           PEA         INTIN
           PEA         CONTRL
           PEA         ADDROUT
           PEA         ADDRIN
           PEA         INTOUT
           PEA         INTIN
           PEA         GLOBAL
           PEA         CONTRL
           PEA         VDIPB
           PEA         AESPB             ;End of macro code
           MOVE.L      #STACK,A7         ;Point stack pointer to top of our stack area

; AP_INIT call: Initialize our application, ID returned in AP_ID
           LEA         CONTRL,A3         ;Code is from AssemPro macro
           MOVE        #10,(A3)+
           MOVE        #0,(A3)+
           MOVE        #1,(A3)+
           MOVE        #0,(A3)+
           MOVE        #0,(A3)
           MOVE.L      AESPTR,D1
           MOVE        #$C8,D0
           TRAP        #2
           MOVE        INTOUT,AP_ID      ;End of macro code

; GRAF_HANDLE call: Initializes graphic workstation, return ID in GR_HANDLE
           LEA         CONTRL,A3         ;Code is from AssemPro macro
           MOVE        #77,(A3)+
           MOVE        #0,(A3)+
           MOVE        #5,(A3)+
           MOVE        #0,(A3)+
           MOVE        #0,(A3)
           MOVE.L      AESPTR,D1
           MOVE        #$C8,D0
           TRAP        #2
           LEA         INTOUT,A3
           LEA         GR_HANDLE,A4
           MOVE.L      (A3)+,(A4)+
           MOVE.L      (A3)+,(A4)+
           MOVE        (A3),(A4)         ;End of macro code

; Find DESKTOP.INF file
           LEA         DEF_NAME,A6       ;Point to filename to open
           MOVE        #10,-(SP)         ;DRVMAP function call, returns active drives as set bits in a word
           TRAP        #13               ;Call BIOS
           ADDQ.L      #2,SP             ;Realign stack
           BTST        #2,D0             ;Is drive C installed?
           BEQ.S       TRY_DRV_A         ;No, file MUST be on A or does not exist
           MOVE        #0,-(SP)          ;Open status - Read only
           PEA         0(A6)             ;File name to open on stack
           MOVE        #$3D,-(SP)        ;OPEN function number
           TRAP        #1
           ADDQ.L      #8,SP
           TST.W       D0                ;Was file on drive C?
           BPL.S       IS_ON_C           ;Yes, o.k. to load
TRY_DRV_A  MOVE.B      #"A",(A6)         ;Change drive name to 'A'
           MOVE        #0,-(SP)          ;Read only
           PEA         0(A6)             ;Point to file name
           MOVE        #$3D,-(SP)        ;OPEN file for read
           TRAP        #1
           ADDQ.L      #8,SP
IS_ON_C    MOVE.W      D0,FILE_HANDL     ;Save handle number
           BMI         JUST_WAIT         ;If error, exit program
RD_DATA    PEA         BUFFER            ;Buffer pointer to stack
           MOVE.L      #80,-(SP)         ;Read 80 bytes
           MOVE        FILE_HANDL,-(SP)  ;File handle onto stack
           MOVE        #$3F,-(SP)        ;READ function call
           TRAP        #1
           ADD         #12,SP
           MOVE.L      D0,-(SP)          ;Save any error
           MOVE        FILE_HANDL,-(SP)  ;Handle number onto stack
           MOVE        #$3E,-(SP)        ;CLOSE file function
           TRAP        #1
           ADDQ.L      #4,SP
           MOVE.L      (SP)+,D0          ;Retrieve any error
           BMI         JUST_WAIT         ;If error, do nothing

; V_OPNVWK VDI call: opens graphic workstation
           LEA         CONTRL,A3         ;Code from AssemPro macro
           MOVE        #100,(A3)
           MOVE        #0,2(A3)
           MOVE        #11,6(A3)
           MOVE        GR_HANDLE,12(A3)
           LEA         INTIN,A4
           LEA         WORK_IN,A3
           MOVEQ       #10,D3
LOOP1      MOVE        (A3)+,(A4)+
           DBRA        D3,LOOP1
           MOVE.L      VDIPTR,D1
           MOVE        #$73,D0
           TRAP        #2
           LEA         WORK_OUT,A4
           LEA         INTOUT,A3
           MOVEQ       #44,D3
LOOP2      MOVE        (A3)+,(A4)+
           DBRA        D3,LOOP2
           LEA         PTSOUT,A3
           MOVEQ       #11,D3
LOOP3      MOVE        (A3)+,(A4)+
           DBRA        D3,LOOP3
           LEA         HANDLE,A3
           MOVE        CONTRL+12,(A3)    ;End of macro code

; Now we look for specific item strings in the DESKTOP file
           MOVE.B      #"b",D0           ;Look for a lower case b, this string contains printer info
           BSR         LOOK_STRNG        ;This call returns pointer to desired string
           CLR.W       D0                ;Clear for rotation
           MOVE.W      #5,D1             ;Do 6 bits
BIT_LOOP   MOVE.B      (A6)+,D2          ;Get ascii value (0=30, 1=31)
           LSR.B       #1,D2             ;Get bit zero to carry flag
           ROXR.B      #1,D0             ;Move bit into D0 from right
           DBRA        D1,BIT_LOOP       ;Next byte
           LSR.B       #2,D0             ;Align to bit 0
           MOVE        D0,-(SP)          ;Put finished byte (actually word) onto stack
           MOVE        #33,-(SP)         ;SETPRT function of XBIOS
           TRAP        #14               ;XBIOS trap call
           ADDQ.L      #4,SP
           MOVE.B      #"c",D0           ;Look for lowercase c, this string has colors and other things
           BSR         LOOK_STRNG
           MOVE.W      #15,D7            ;Do 16 colors
           CLR.W       D6                ;Color zero
           LEA         CONV_COLOR,A5     ;Color conversion table, the VDI requires values between 0 and 1000
COL_LOOP1  LEA         BUF,A4            ;Temporary buffer for color values
           MOVE.W      #2,D1             ;There are three intensity values per color
COL_LOOP2  MOVE.B      (A6)+,D0          ;Get the value, will be ASCII 0 to 7
           SUB.B       #"0",D0           ;Remove ASCII part, make it binary 0 to 7
           LSL.B       #1,D0             ;Multiply by two, make it a word index
           EXT.W       D0                ;Clear upper byte of word
           MOVE.W      0(A5,D0.W),(A4)+  ;Get color intensity value into temporary buffer
           DBRA        D1,COL_LOOP2      ;Next intensity value (remember, Red-Green-Blue)

; VS_COLOR VDI call: change workstation colors
           LEA         CONTRL,A3         ;This code is from AssemPro macro
           MOVE        #14,(A3)
           MOVE        #0,2(A3)
           MOVE        #4,6(A3)
           MOVE        HANDLE,12(A3)
           LEA         INTIN,A3
           MOVE        D6,(A3)+
           LEA         BUF,A4
           MOVE.L      (A4)+,(A3)+
           MOVE        (A4),(A3)
           MOVE.L      VDIPTR,D1
           MOVE        #$73,D0
           TRAP        #2                ;End of macro code

           ADDQ.W      #1,D6             ;Next color index
           DBRA        D7,COL_LOOP1      ;Do next color
           MOVE.B      (A6)+,D0          ;Next item in string is the mouse click speed
           SUB.B       #"0",D0           ;Remove ASCII part, make it 0-4
           EXT.W       D0                ;Clear upper byte of word

; EVNT_DCLICK AES call: Changes mouse click speed
           LEA         CONTRL,A3         ;Code is from AssemPro macro
           MOVE        #26,(A3)+
           MOVE        #2,(A3)+
           MOVE        #1,(A3)+
           MOVE        #0,(A3)+
           MOVE        #0,(A3)
           LEA         INTIN,A3
           MOVE        D0,(A3)+
           MOVE        #1,(A3)
           MOVE.L      AESPTR,D1
           MOVE        #$C8,D0
           TRAP        #2
           MOVE        INTOUT,D0         ;End of macro

           CLR.B       D7                ;Clear register for rotation
           MOVE.B      (A6)+,D1          ;Next byte in string is keybeep on/off
           LSR.B       #1,D1             ;Move bit to X carry flag
           ROXR.B      #1,D7             ;Get bit into D7
           LSR.B       #1,D7             ;Move it an extra bit right
           MOVE.B      (A6)+,D1          ;Next byte in string is bell tone on/off
           LSR.B       #1,D1             ;Get bit to X carry flag
           ROXR.B      #1,D7             ;Move bit into D7
           LSR.B       #5,D7             ;Put both bits in the proper place within byte
           PEA         SET_CON_BT        ;We need to change these bits from supervisor mode, this is our routine to do it
           MOVE        #38,-(SP)         ;SUPEXEC function
           TRAP        #14               ;XBIOS call
           ADDQ.L      #6,SP
           BSR         MAKE_NUM          ;Convert next ASCII digits into a binary number
           MOVE.W      D7,D6             ;Save delay rate to D6
           BSR         MAKE_NUM          ;Convert next number also
           MOVE        D7,-(SP)          ;Put repeat rate on stack
           MOVE        D6,-(SP)          ;Put delay rate on stack
           MOVE        #35,-(SP)         ;Set keyboard rate and delay
           TRAP        #14
           ADDQ.L      #6,SP
           BRA         FINISH            ;We is done

SET_CON_BT MOVE.B      CONTERM,D0        ;Get current settings in low memory (we are in supervisor mode)
           AND.B       #%11111010,D0     ;Mask bits to set (bits 0 and 2)
           OR.B        D7,D0             ;OR in new settings (may be zero or one)
           MOVE.B      D0,CONTERM        ;Store modified byte
           RTS                           ;Will return out of supervisor mode

MAKE_NUM   MOVE.B      (A6)+,D7          ;Get ASCII number 0-9
           SUB.B       #"0",D7           ;Remove ASCII, make it binary 0-9
           MULU        #10,D7            ;Move digit to tens place
           ADD.B       (A6)+,D7          ;Add in next digit (ones place)
           SUB.B       #"0",D7           ;Remove ASCII value, will leave ones digit as 0-9
           EXT.W       D7                ;Clear upper byte of word
           RTS

LOOK_STRNG LEA         BUFFER,A6         ;Point to our buffer
           MOVE.W      #78,D1            ;Max number of characters to look through
LOOK_LOOP  CMP.B       (A6)+,D0          ;Is this the start of the string we want?
           DBEQ        D1,LOOK_LOOP      ;Look some more if it isn't
           TST.W       D1                ;D1 will be minus if we didn't find it
           BMI.S       FINISH1           ;Didn't find it, exit program
           RTS                           ;Else return with A6 pointing to correct spot

FINISH1    LEA         4(SP),SP          ;Remove return address from stack

; V_CLSVWK VDI call: Close graphic workstation
FINISH     LEA         CONTRL,A3         ;From AssemPro macro
           MOVE        #101,(A3)
           MOVE        #0,2(A3)
           MOVE        #0,6(A3)
           MOVE        HANDLE,12(A3)
           MOVE.L      VDIPTR,D1
           MOVE        #$73,D0
           TRAP        #2                ;End of macro

; EVNT_MULTI AES call: Wait for nothing forever
JUST_WAIT  LEA         CONTRL,A3         ;This is part of the AssemPro EVNT_MULTI macro call.
           MOVE        #25,(A3)+         ;Part of it was removed because the macro generates
           MOVE        #16,(A3)+         ;code to set all of the parameters of the EVNT_MULTI
           MOVE        #7,(A3)+          ;call, but only those functions needed must have the
           MOVE        #1,(A3)+          ;parameters set. In this case we only look for a message
           MOVE        #0,(A3)           ;(which is ignored) so the only parameters we need are
           LEA         INTIN,A3          ;the flag word and the message buffer.
           MOVE        #%10000,(A3)+
           LEA         ADDRIN,A3
           LEA         MBUF,A4
           MOVE.L      A4,(A3)
           MOVE.L      AESPTR,D1
           MOVE        #$C8,D0
           TRAP        #2                ;End of macro
           BRA         JUST_WAIT         ;If we ever return here, just recall EVNT_MULTI

           DATA
CONV_COLOR DC.W        0                 ;Intensity 0
           DC.W        143               ;    "     1
           DC.W        286               ;    "     2
           DC.W        429               ;    "     3
           DC.W        571               ;    "     4
           DC.W        714               ;    "     5
           DC.W        857               ;    "     6
           DC.W        1000              ;    "     7

DEF_NAME   DC.B        "C:\DESKTOP.INF",0 ;Name of data file

           BSS
FILE_HANDL DS.W        1                 ;File handle
BUF        DS.W        4
BUFFER     DS.B        2                 ;Buffer for file Read, 80 bytes
MBUF       DS.B        78                ;MBUF is the message buffer used in EVNT_MUTI. We don't actually need it
                                         ;so we'll use part of the file buffer

           DS.W        200               ;Room for stack to grow down into
STACK      DS.W        1                 ;Top of stack

           END
